medux_online/plugins/homepage/urls.py
from django.urls import path, include

from . import views
from ...core.api.interfaces import IDashboardURL

# from ...core.views import TermsView, PrivacyView

app_name = "homepage"

homepage_urlpatterns = [
    path("", views.HomepageList.as_view(), name="list"),
    path("add/", views.HomepageCreate.as_view(), name="add"),
    path("<int:pk>/", views.HomepageUpdate.as_view(), name="detail"),
    path(
        "<int:pk>/update/",
        views.HomepageUpdate.as_view(),
        name="update",
    ),
    path(
        "<int:pk>/delete/",
        views.HomepageDelete.as_view(),
        name="delete",
    ),
    path("<int:pk>/blocks/", views.BlockList.as_view(), name="block-list"),
    path(
        "<int:pk>/blocks/sort/",
        views.BlockSort.as_view(),
        name="block-sort",
    ),
    path(
        "<int:homepage_pk>/blocks/add/<str:block_type>/",
        views.BlockCreate.as_view(),
        name="block-add",
    ),
]

block_urlpatterns = [
    path("<int:pk>/", views.BlockDetail.as_view(), name="detail"),
    path("<int:pk>/update/", views.BlockUpdate.as_view(), name="update"),
    path("<int:pk>/delete/", views.BlockDelete.as_view(), name="delete"),
]


class HomepageDashboardURLs(IDashboardURL):
    urlpatterns = [
        path(
            "homepage/",
            include((homepage_urlpatterns, "homepage"), namespace="homepage"),
        ),
        path("block/", include((block_urlpatterns, "block"), namespace="block")),
    ]


root_urlpatterns = [
    path("", views.HomepageView.as_view(), name="home"),
    # path("terms/", TermsView.as_view(), name="terms"),
    # path("privacy/", PrivacyView.as_view(), name="privacy"),
]

medux_online/urls.py
from functools import wraps

from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.core.exceptions import PermissionDenied
from django.urls import path, include
from gdaps.pluginmanager import PluginManager

from .core.api.interfaces import IDashboardURL
from .core.views import DashboardView

app_name = "medux_online"


def medux_site_required(test_func=None):
    """
    Decorator for views that checks that the current site is the main
    medux site. If not, raise a PermissionDenied error
    """

    def site_is_medux(view_func):
        @wraps(view_func)
        def _wrapped_view(request, *args, **kwargs):
            if request.site == 1:
                return True
            raise PermissionDenied

        return _wrapped_view

    return site_is_medux


# create a pluggable "dashboard" urlpatterns hook
dashboard_urlpatterns = [
    path("", DashboardView.as_view(), name="index"),
]
for up in IDashboardURL:
    dashboard_urlpatterns += up.urlpatterns

urlpatterns = [
    # TODO make admin only available on SIDE_ID=1
    path("admin/", admin.site.urls, name="admin"),
    path(
        "dashboard/",
        # dashboard is no namespace, only part of the URL
        include((dashboard_urlpatterns, ""), namespace=""),
        name="index",
    ),
    path("__debug__/", include("debug_toolbar.urls")),
] + PluginManager.urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

medux_online/plugins/homepage/models.py
from datetime import datetime
from pathlib import Path

from colorfield.fields import ColorField
from django.contrib.auth.signals import user_logged_in
from django.contrib.sites.models import Site
from django.core.files.storage import Storage
from django.core.validators import MinValueValidator, MaxValueValidator, validate_slug
from django.db import models
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.utils.text import slugify, re_camel_case
from django.utils.translation import gettext_lazy as _
from polymorphic.models import PolymorphicModel

# FIXME: Bah, that ZipExtractorStorage can't work.
from medux.common.models import TenantModelMixin


# from zipfile import ZipFile
# # thanks to https://goodcode.io/articles/django-singleton-models/
# class SingletonModel(models.Model):
#     class Meta:
#         abstract = True
#
#     def save(self, *args, **kwargs):
#         self.__class__.objects.exclude(id=self.id).delete()
#         super(SingletonModel, self).save(*args, **kwargs)
#
#     @classmethod
#     def load(cls):
#         try:
#             return cls.objects.get()
#         except cls.DoesNotExist:
#             return cls()


class ZipExtractorStorage(Storage):
    """Dummy"""

    def save(self, name, content, max_length=None):
        # with ZipFile(name) as zip_file:
        #     upload_path = self.get_upload_path(self, self.package.name)
        #     zip_file.extractall(self.get_upload_path() / self.slug)
        #     # TODO: do something with uploaded file
        pass


class Theme(models.Model):
    # TODO: determine a way to allow only own tenant's themes, or to explicitly allow others, per theme
    def get_upload_path(self, instance: "Theme", filename: str):
        return Path("themes")  # / instance.homepage.name

    slug = models.CharField(max_length=64, validators=[validate_slug])
    title = models.CharField(max_length=255)
    package = models.FileField(
        upload_to=get_upload_path, storage=ZipExtractorStorage, null=True, blank=True
    )

    def __str__(self):
        return self.title

    def save(self, *args, **kwargs):

        if not self.slug:
            self.slug = slugify(self.title)
        super().save(*args, **kwargs)


class ColoredMixin(models.Model):
    class Meta:
        abstract = True

    color_accent = ColorField()
    text_primary = ColorField()
    text_secondary = ColorField()
    text_success = ColorField()
    text_danger = ColorField()
    text_warning = ColorField()
    text_info = ColorField()
    text_light = ColorField()
    text_dark = ColorField()
    text_muted = ColorField()
    text_white = ColorField()

    bg_primary = ColorField()
    bg_secondary = ColorField()
    bg_light = ColorField()
    bg_dark = ColorField()


class Homepage(TenantModelMixin, Site):
    subtitle = models.CharField(
        _("Subtitle"),
        help_text=_("A subtitle that appears on the homepage, depending on the theme."),
        max_length=255,
        blank=True,
        null=True,
    )
    logo = models.ImageField(
        _("Logo"), help_text=_("Homepage Logo"), blank=True, null=True
    )

    theme = models.ForeignKey(Theme, default=1, on_delete=models.SET_DEFAULT)

    def __str__(self):
        return self.name


class MultiHomepagesMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to more than one homepage."""

    class Meta:
        abstract = True

    homepages = models.ManyToManyField(Homepage)


class SingleHomepageMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to exactly one homepage."""

    class Meta:
        abstract = True

    homepage = models.ForeignKey(Homepage, on_delete=models.CASCADE)


# Note: SingleHomepageMixin is 2nd in the list, so that objects is called first from PolymorphicModel.
# This is needed for PolymorphicModel to get no ManagerInheritanceWarning.
class Block(PolymorphicModel):
    """A basic HTML/renderable block.

    You can either create a Block directly, and fill out the title and content, and it will be rendered
    as HTML. The order of the block is determined by the "weight" property: the higher the weight, the
    "deeper" sinks the block down.

    If you subclass Block, you can add model fields. Just make sure you add these fields to the
    "additional_fields" list property, so they will be added to the template context.
    """

    class Meta:
        verbose_name = _("Common block")
        verbose_name_plural = _("Common blocks")

    homepage = models.ForeignKey(
        Homepage, on_delete=models.CASCADE, related_name="blocks"
    )

    #: should the title be editable?
    edit_title = False
    #: should the content be editable
    edit_content = False

    additional_fields = []
    template_name = "block.html"

    title = models.CharField(_("Title"), max_length=50, blank=True)
    show_title = models.BooleanField(
        default=True, verbose_name=_("Show title on homepage")
    )
    content = models.TextField(_("Content"), blank=True)
    weight = models.SmallIntegerField(_("Weight"), default=0)

    visible = models.BooleanField(_("Visible"), default=False)

    # def __str__(self):
    # (
    #     f"{self.title} ({self.tenant.name})"
    #     if self.title
    #     else f"{self._meta.verbose_name.capitalize()} ({self.tenant.name})"
    # )

    def verbose_name(self):
        return self._meta.verbose_name

    def btype(self) -> str:
        """:returns the block type (=basically the lowercase class name) as string."""
        class_name = self.__class__.__name__
        return re_camel_case.sub(r"_\1", class_name).strip("_").lower()

    def __str__(self):
        return f"{self.title} ({self.homepage})"

    @property
    def tenant(self):
        return self.homepage.tenant


class Header(Block):
    class Meta:
        verbose_name = _("Header")
        verbose_name_plural = _("Headers")

    template_name = "header.html"
    additional_fields = ["logo", "background_image"]

    logo = models.ImageField(blank=True, null=True)
    background_image = models.ImageField(blank=True, null=True)


class News(Block):
    class Meta:
        verbose_name = _("News")
        verbose_name_plural = _("News")

    template_name = "news.html"


class OpeningHours(Block):
    """Opening hours, that can be rendered in a block"""

    class Meta:
        verbose_name = _("Opening hours")
        verbose_name_plural = _("Opening hours")

    template_name = "opening_hours.html"
    additional_fields = ["entries", "weekdays_count"]

    def weekdays_count(self) -> int:
        """returns distinct count of week days that are open.

        E.g. if opening hours are MO 8-12, WE 8-12 + 15-18, FR 8-12; then it would return 3."""
        # FIXME: use a distinct call
        return self.entries.count()


class OpeningHourSlot(models.Model):
    """Single block of opening hours, e.g. '8:00 - 12:00'"""

    DAYS_CHOICES = (
        (0, _("MO")),
        (1, _("TU")),
        (2, _("WE")),
        (3, _("TH")),
        (4, _("FR")),
        (5, _("SA")),
        (6, _("SU")),
    )
    day = models.PositiveSmallIntegerField(
        choices=DAYS_CHOICES,
        validators=[MinValueValidator(0), MaxValueValidator(6)],
        null=True,
    )
    start = models.TimeField()
    end = models.TimeField()
    opening_hours = models.ForeignKey(
        OpeningHours, on_delete=models.CASCADE, related_name="entries"
    )

    def __str__(self) -> str:
        return f"{self.day_str()}, {self.start} - {self.end}"

    def is_today(self) -> bool:
        return datetime.today().weekday() == self.day

    def day_str(self) -> str:
        """returns the day as (translated) 2 char str."""
        return self.DAYS_CHOICES[self.day][1]


class Map(Block):
    """A Block with a GDPR-compliant map image pointing to a OSM, Google Maps, or other map service point."""

    class Meta:
        verbose_name = _("Map")
        verbose_name_plural = _("Maps")

    template_name = "map.html"
    additional_fields = ["address", "link_image", "location_url"]

    address = models.CharField(max_length=128, verbose_name=_("Address"))
    link_image = models.ImageField(upload_to="map_images", blank=True, null=True)
    location_url = models.URLField(
        max_length=255,
        verbose_name=_("Location URL"),
        help_text=_("Link that points to OpenStreetMap, Google Maps etc."),
    )


class Contact(Block):
    class Meta:
        verbose_name = _("Contact")
        verbose_name_plural = _("Contacts")

    def get_homepage_email(self):
        return self.tenant.email  # FIXME

    additional_fields = ["email"]
    template_name = "contact.html"

    email = models.EmailField()


class Team(Block):
    class Meta:
        verbose_name = _("Team")
        verbose_name_plural = _("Teams")

    template_name = "team.html"
    additional_fields = ["members"]


class TeamMember(SingleHomepageMixin, models.Model):
    """A team member with a name, function, description and photo."""

    class Meta:
        verbose_name = _("Team member")
        verbose_name_plural = _("Team members")

    @staticmethod
    def _get_team():
        pass

    team = models.ForeignKey(Team, on_delete=models.CASCADE, related_name="members")
    name = models.CharField(_("Name"), max_length=50)
    function = models.CharField(_("Function"), max_length=50, blank=True)
    description = models.TextField(_("Description"), blank=True)
    image = models.ImageField(_("Photo"), blank=True, null=True)

    def __str__(self):
        return self.name

    def save(
        self, force_insert=False, force_update=False, using=None, update_fields=None
    ):
        # FIXME: make homepage links work
        team, created = Team.objects.get_or_create(homepage=self.homepage)
        if created:
            team.tenant = self.homepage.foo

        self.team = team
        super().save(force_insert, force_update, using, update_fields)

medux_online/plugins/homepage/templates/homepage/base.html
{% extends "core/page.html" %}

medux_online/plugins/homepage/templates/homepage/block_form.html
{% extends "conjunto/modal_form.html" %}

medux_online/plugins/homepage/templates/homepage/block_list.html
{% load i18n %}
<div class="card mb-3">
  <div class="card-header">
    {#     Blocks section title and "Add block" dropdown#}
    <h3 class="mt-3 d-flex justify-content-between">
      <span>{% translate 'Blocks' %}</span>
    </h3>
    <div class="card-actions">
      <div class="btn-toolbar">
        <div class="btn-group me-2">
          <div class="dropdown">

            <button class="btn btn-outline-secondary dropdown-toggle"
                    type="button"
                    id="dropdownAvailableBlocks"
                    data-bs-toggle="dropdown"
                    aria-expanded="false">
              <i class="bi bi-plus-lg"></i>
              {% translate 'Add block' %}
            </button>

            <ul class="dropdown-menu" aria-labelledby="dropdownAvailableBlocks">
              {% for block in available_blocks %}
                <li>
                  <button class="dropdown-item" hx-get="{% url 'homepage:block-add' homepage_pk=homepage.pk block_type=block.slug %}" hx-target="#dialog">
                    {{ block.title }}
                  </button>
                </li>
              {% endfor %}
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>

  {% if homepage.blocks.all %}
    <div class="card-body">
      <div id="list-group-blocks" class="list-group">
        {% for object in object_list %}
          <div class="list-group-item">
            <div class="row align-items-center">
              <div class="col-auto"><span class="handle"><i class="bi bi-three-dots-vertical"></i></span></div>
              {#    <div class="col-auto">#}
              {#      <a href="#">#}
              {#        <span class="avatar" style="background-image: url(...)"></span>#}
              {#      </a>#}
              {#    </div>#}
              <div class="col text-truncate">
                <input type="hidden" value="{{ object.weight }}">
                <a href="#" class="text-reset d-block">{{ object.verbose_name }}</a>
                <div class="d-block text-muted text-truncate mt-n1">{{ object.title }}</div>
              </div>
              <div class="col-auto">
                <label for="checkbox-visible-{{ object.pk }}" class="form-check form-switch">
                  <input id="checkbox-visible-{{ object.pk }}" class="form-check-input" type="checkbox"
                         {% if object.visible %}checked{% endif %}>
                  <span class="form-check-label">{% translate 'visible' %}</span>
                </label>
              </div>
              <div class="col-auto">
                <a href="#" hx-get="{% url 'block:update' pk=object.pk %}" class="list-group-item-actions">
                  <i class="bi bi-pencil"></i>
                </a>
                <a href="#"
                   class="list-group-item-actions"
                   hx-post="{% url 'block:delete' pk=object.pk %}"
                   hx-target="#list-group-blocks"
                >
                  <i class="bi bi-trash"></i>
                </a>
              </div>
            </div>
          </div>
        {% endfor %}
      </div>
    </div>
  {% endif %}
</div>

medux_online/plugins/homepage/templates/homepage/block_toggle_htmx.html
{% load i18n %}

<div
    class="form-check form-switch me-2"   {# FIXME: align-middle!!! #}
    id="btn-check-visible-block-{{ object.pk }}"
>
  <input
      type="checkbox"
{#      id="btn-check-visible-input-{{ object.pk }}"#}
      name="block-visible-{{ object.pk }}"
      class="form-check-input"
      {% if object.visible %}checked{% endif %}
      hx-post="{% url 'block-toggle' object.pk %}"
      hx-target="#btn-check-visible-block-{{ object.pk }}"
  >
  <label class="form-check-label" for="btn-check-visible-input-{{ object.pk }}"> {% translate 'Visible' %}</label>
</div>

medux_online/plugins/homepage/templates/homepage/card.html
{% extends "base.html" %}
{% load i18n %}

{% block body %}
  <div class="card m-4">
    {#  <img src="..." class="card-img-top" alt="...">#}
    <div class="card-body">
      <h5 class="card-title">{% block card-title %}{% endblock %}</h5>
      <div class="card-text">{% block card-text %}{% endblock %}</div>
      {#    <a href="#" class="btn btn-primary">Go somewhere</a>#}
    </div>
  </div>
{% endblock %}

medux_online/plugins/homepage/templates/homepage/homepage.html
{% extends "common/html.html" %}
{% load i18n static %}

{% block body %}
  {% for block in blocks %}
    {{ block }}
  {% empty %}
    <div class="px-4 pt-5 my-5 text-center border-bottom">
      <h1 class="display-4 fw-bold">{% translate 'Under construction...' %}</h1>
      <div class="col-lg-6 mx-auto">
        <p class="lead mb-4">{% translate 'This site is currently under construction. Please stay tuned and drop by later.' %}</p>
        <div class="d-grid gap-2 d-sm-flex justify-content-sm-center mb-5">
{#          <button type="button" class="btn btn-primary btn-lg px-4 me-sm-3">Primary button</button>#}
{#          <button type="button" class="btn btn-outline-secondary btn-lg px-4">Secondary</button>#}
        </div>
      </div>
      <div class="overflow-hidden" style="height: 40vh;">
        <div class="container px-5">
          <svg xmlns="http://www.w3.org/2000/svg" width="160" height="160" fill="orange" class="bi bi-cone-striped" viewBox="0 0 16 16">
            <path d="m9.97 4.88.953 3.811C10.159 8.878 9.14 9 8 9c-1.14 0-2.158-.122-2.923-.309L6.03 4.88C6.635 4.957 7.3 5 8 5s1.365-.043 1.97-.12zm-.245-.978L8.97.88C8.718-.13 7.282-.13 7.03.88L6.275 3.9C6.8 3.965 7.382 4 8 4c.618 0 1.2-.036 1.725-.098zm4.396 8.613a.5.5 0 0 1 .037.96l-6 2a.5.5 0 0 1-.316 0l-6-2a.5.5 0 0 1 .037-.96l2.391-.598.565-2.257c.862.212 1.964.339 3.165.339s2.303-.127 3.165-.339l.565 2.257 2.391.598z"/>
          </svg>
          {# <img src="{% static 'img/under-construction.png' %}" class="img-fluid border rounded-3 shadow-lg mb-4" alt="Under construction image" loading="lazy" width="700" height="500">#}
        </div>
      </div>
    </div>
    <p class="small text-black-50 mt-5 mb-3 text-center">© <span class="">nerdocs</span> 2013–{% now "Y" %}</p>

  {% endfor %}
{% endblock %}

{% block styles %}
  {#  FIXME: load theme.css from dynamic location #}
  <link rel="stylesheet" href="{% static "css/theme.css" %}">
{% endblock %}

medux_online/plugins/homepage/templates/homepage/homepage_form.html
{% extends "homepage/base.html" %}
{% load crispy_forms_tags i18n breadcrumbs %}


{% block page_title %}
  {% if homepage.pk %}
    <span id="homepage-{{ homepage.pk }}-title">{% translate 'Edit homepage' %}: {{ homepage }}</span>
  {% else %}
    <span id="homepage-new-title">{% translate 'Add homepage' %}</span>
  {% endif %}
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% if homepage.pk %}
    {% breadcrumb "Edit homepage" "homepage:update" pk=homepage.pk %}
  {% else %}
    {% breadcrumb "Add homepage" "homepage:add" %}
  {% endif %}
{% endblock %}

{% block content %}
  <div class="card mb-3 homepage-{{ homepage.pk|default:"new" }}">
    <div class="card-header">
      <h3 class='d-flex justify-content-between'>
        <span>{% translate 'Master data' %}</span>
      </h3>
    </div>

    <!-- master data -->
    <div class="card-body">
      <form id='homepage-{{ homepage.pk|default:"new" }}-master_data-form' action="." method="post">
        {% crispy form %}
        {{ form|as_crispy_errors }}
      </form>
    </div>
  </div>

  {% if homepage.pk %}
    <!-- block list -->
    <div id="block-list"
         hx-trigger="load,medux:homepage:block-added from:body, medux:homepage:block-deleted from:body"
         hx-get="{% url 'homepage:block-list' homepage.pk %}"
         hx-disinherit="*">
{#      {% include 'homepage/block_list.html' with object_list=homepage.blocks.all %}#}
    </div>
  {% endif %}
{% endblock %}


{#    {% load i18n %}#}
{#    <div class="card">#}
{#      <div class="card-header card-header-light">#}
{#        <div>#}
{#          <div class="row align-items-center">#}
{#            <div class="col-auto">#}
{#              <span class="avatar" style="background-image: url({{ tenant.picture }})"></span>#}
{#            </div>#}
{#            <div class="col">#}
{#              <div class="card-title">{{ tenant }}</div>#}
{#              <div class="card-subtitle text-black-50">{{ tenant.uuid }}</div>#}
{#            </div>#}
{#          </div>#}
{#        </div>#}
{#        <div class="card-actions btn-actions">#}
{#  <div class="dropdown"> #}
{#    <a href="#" class="btn-action dropdown-toggle" data-bs-toggle="dropdown" #}
{#        aria-haspopup="true" aria-expanded="false"> #}
{#        <i class="bi bi-three-dots-vertical"></i> #}
{#    </a> #}
{#    <div class="dropdown-menu dropdown-menu-end"> #}
{#      <a class="dropdown-item" href="#">Edit user</a> #}
{#      <a class="dropdown-item" href="#">Change permissions</a> #}
{#      <a class="dropdown-item text-danger" href="#">Delete user</a> #}
{#    </div> #}
{#  </div> #}
{#          <button type='button' class="btn-action" @click='edit=true'>#}
{#            <i class="bi bi-pencil"></i>#}
{#          </button>#}
{#        </div>#}
{#      </div>#}
{#      <div class="card-body">#}
{#        <div class='row'>#}
{#            <div class='col'>#}
{#                <div class="mb-3">#}
{#                  <label class="form-label">{% translate 'Address' %}</label>#}
{#                  <input type="text" class="form-control" name="address" x-model='address'>#}
{#                </div>#}
{#                <div class="mb-3">#}
{#                  <label class="form-label">{% translate 'Phone' %}</label>#}
{#                  <input type="text" class="form-control" name="phone" x-model='phone'>#}
{#                </div>#}
{#                <div class="mb-3">#}
{#                  <label class="form-label">{% translate 'Email' %}</label>#}
{#                  <input type="text" class="form-control" name="email" x-model='email'>#}
{#                </div>#}
{#            </div>#}
{#        </div>#}
{#      </div>#}
{#    </div>#}

medux_online/plugins/homepage/templates/homepage/homepage_list.html
{% extends "homepage/base.html" %}
{% load crispy_forms_tags i18n breadcrumbs %}

{% block page_title %}
  {% translate 'Homepages' %}
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Homepage list" "homepage:list" %}
{% endblock %}

{% block content %}
  <div id="homepage-list">

    <div class="row row-cards">
      {% for homepage in object_list %}

        {% load i18n %}
        <div class="col-12 col-md-6 col-lg-4">
          <div class="card card-link" >
            <div class="card-header card-header-light">
              <h3 class="card-title">
                <span>{{ homepage }}</span>
              </h3>
              <div class="card-actions">
                <a
                    href="{% url 'homepage:update' pk=homepage.pk %}"
                    title="{% translate 'Edit' %}"
                    class="btn btn-sm"
                >
                  <i class='bi bi-pencil'></i>
                </a>
                <button
                    type="button"
                    data-bs-toggle="modal"
                    data-bs-target="#homepage-{{homepage.pk}}-delete-modal"
                    id="delete-homepage-{{ homepage.pk }}"
                    class="btn btn-sm delete-homepage"
                ><i class="bi bi-trash text-danger"></i>
                </button>
              </div>
            </div>
            <img class="card-img-top img-responsive" src="#" alt="Screenshot">
            <div class="card-footer text-center">
              <span class="text-muted small">{{ homepage.domain }}</span>
            </div>
          </div>
        </div>
        </div>
        <div id='homepage-{{homepage.pk}}-delete-modal' class='modal' tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h1 class="modal-title fs-5" id="exampleModalLabel">
                  {% blocktranslate with domain=homepage.domain %}Delete {{ domain }}?{% endblocktranslate %}</h1>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
              </div>
              <div class="modal-body">
                <div class='modal-content'>
                  <p>
                    {% blocktranslate with domain=homepage.domain %}
                      Do you really want to delete the homepage <b>{{domain}}</b>?
                    {% endblocktranslate %}
                  </p>
                </div>
              </div>
              <div class="modal-footer">
                <form action="{% url 'homepage:delete' homepage.pk %}" method='post'>
                  {% csrf_token %}
                  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
                    {% translate 'Cancel' %}
                  </button>
                  <button
                      type="submit"
                      class="btn btn-danger"
                      data-bs-dismiss="modal"
                  >{% translate 'Delete' %}</button>
                </form>
              </div>
            </div>
          </div>
        </div>
      {% endfor %}
  </div>


{% endblock %}

medux_online/plugins/homepage/templates/homepage/staticpage.html
{% extends "homepage/card.html" %}
{% load i18n %}

{% block title %}{{ title }}{% endblock %}

{% block card-title %}{{ title }} <span class="position-absolute top-0 end-0 translate-middle badge rounded-pill bg-info">v{{ object.version }}</span>{% endblock %}

{% block card-text %}
  {{ object.content }}
{% endblock %}

medux_online/plugins/homepage/templates/homepage/tenant_homepage_addon.html
{% load i18n %}
<div class="card">
  <div class="card-header">
    <h3 class="card-title">{% translate 'Websites' %}</h3>
  </div>
  <div class="card-body">
    <table class="table table-vcenter card-table">
      <thead>
      <tr>
        <th>{% translate 'Name' %}</th>
        <th>{% translate 'Domain' %}</th>
        <th>{% translate 'Actions' %}</th>
      </tr>
      </thead>
      <tbody>
      {% for homepage in tenant.homepage_set.all %}
        <tr>
          <td>{{ homepage.name }}</td>
          <td class="text-muted">
            {{ homepage.domain }}
          </td>
          <td>
            <a class="btn btn-secondary btn-sm"
               href="{% url 'homepage:detail' pk=homepage.pk %}">
              <i class="bi bi-pencil"></i>
            </a>
          </td>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  </div>
</div>